SUGGESTION:Before posting your question with asking for help try this test. PROBLEM LINK:Author: Khadar Basha DIFFICULTY:EASY PREREQUISITES:Connected component, Depthfirst search, Flood fill algorithm, Sieve of Eratosthenes PROBLEM:You are given N × N grid filled by nonnegative integers. We single out 3 types of numbers on the grid: primes, even nonprimes and odd nonprimes. For each number we define the cost as follows: for the prime number it is the id of this prime in the 0based list of all primes, for even nonprime number X it is X / 2, and for odd nonprime number Y it is (Y + 3) / 2 (the cost of a number is the shortcut for the number of unsuccessful tries to crack the server secured by the password equals to this number; the mentioned formulas for cost in all three cases are clear from the problem statement). Two even nonprime numbers that share a side on the grid are connected to each other. The same is true for odd nonprime numbers. But prime number is not connected to any other number. In this way all cells of the grid form a bidirectional graph that has several connected components (each cell having prime number is a separate component). The cost of the component is defined as the cost of the first cell in this component that we meet traversing the grid in rowmajor order. Now your task is to find the sum of costs over all components. QUICK EXPLANATION:Actually, most of the job has already made while we reformulated the problem above. Now you simply need to loop over all cells of the grid in rowmajor order and if we meet the unvisited cell we add its cost to the answer and run DFS from this cell in the graph constructed above to mark other cells of its connected component as visited. Tip: the total cost could overflow 32bit integer type. Use 64bit type instead. To be able to find the cost of the prime cell fast enough we need to run Sieve of Eratosthenes in advance (even before input the very first test) in order to find all prime numbers. Then we need to create the array of size 10^{7} that contains for each prime its id. Now the cost of each number can be found in O(1). The overall complexity is O(K * log log K + T * N * N). EXPLANATION:As mentioned above at first we run Sieve of Eratosthenes to identify all prime numbers: isPrime[0] = false isPrime[1] = false for i = 2 to K do isPrime[i] = true for i = 2 to sqrt(K) do if isPrime[i] then for j = i * i to K with step i do isPrime[j] = falsewhere K = 10^{7} − 1. Next we fill array of costs. We maintain variable prime_id = 0 for i = 0 to K do if isPrime[i] then cost[i] = prime_id prime_id = prime_id + 1 else cost[i] = i div 2 + (i mod 2) * 2Note the formula for the cost for nonprime number. Now we can input grids and traverse them. We use twodimensional array for i = 1 to N do for j = 1 to N do read A[i][j] visited[i][j] = false Now we can traverse the grid. If we meet visited cell we skip it. Otherwise we always add its cost to the answer and if it is nonprime then run DFS to fill its connected component: total_cost = 0 // this should be a variable of 64bit integer type! for i = 1 to N do for j = 1 to N do if (visited[i][j]) then continue total_cost = total_cost + cost[A[i][j]] if (not isPrime[A[i][j]]) then DFS(i, j) DFS(i, j) is the recursive routine that traverse the grid passing from the cell (i, j) to its neighbors in the graph constructed above: DSF(i, j) if (not visited[i][j]) then visited[i][j] = true for (x, y) in {(i+1, j), (i1, j), (i, j1), (i, j+1)} do if (not isPrime[A[x][y]]) and (A[x][y] is of the same parity as A[i][j]) then DFS(x, y)Note that we pass to the cell (x, y) only if the number in it is nonprime and of the same parity as in the cell (i, j). Missing of any of these checks will definitely lead to WA. Also see tester's solution as a reference to one of the convenient ways how to implement loop: for (x, y) in {(i+1, j), (i1, j), (i, j1), (i, j+1)} do ALTERNATIVE SOLUTION:For some languages (like Java or Python) the recursive implementation of DFS could lead to runtime error due to stack overflow. In this case you need to implement either nonrecursive DFS or BFS (breadthfirst search) to mark cells of each connected component. Another alternative is to use disjointset data structure to do the same job. But this way requires some additional thinking. The alternative very fast method to find all primes is to use Atkin Sieve invented in 2004 by Atkin and Bernstein. It allows to find all primes up to K using O(K / log log K) operations. Check it out first 6 related problems to train yourself at fast implementation of sieve. The remaining 3 problems involves flood fill algorithm. AUTHOR'S AND TESTER'S SOLUTIONS:Author's solution can be found here. RELATED PROBLEMS:SPOJ  6488. Printing some primes  TDPRIMES
This question is marked "community wiki".
asked 15 Jan '13, 15:00

only mistake was... i used 32bit integer for total cost instead of 64 feels like killmenow answered 15 Jan '13, 16:42

Hi, Actually i did the same solution described above in Python but it didn't work (i got Time Limit Exceeded), you can check my attempt here and here. But actually, i was able to find another algorithm for this problem that got accepted, the idea was that i only check for immediate neighbors of any server to know if it should be included or not, of course this may lead to count a server while it shouldn't (i.e. it should have been already cracked), but to be aware of this case i created a Python dictionary that hold information about which server cracked which one ( You can check my solution here, feel free to post any feedback. HTH, answered 16 Jan '13, 02:52
Hm... But are you sure that this solution has complexity O(N * N) per test?
(17 Jan '13, 11:54)
If I'm correct, it would only mean that our test data are weak :) Well, it's impossible to predict with what approaches contestants can come up with to have a test failing each approach.
(17 Jan '13, 12:02)
@anton_lunyov: First of all thanks for your feedback, as for the two test cases that you gave, AFAIK my solution will return 6 and 52 respectively which is correct, and as for the complexity well i am not sure what is the correct answer ;) specially i don't know what is the worst case to get roots of the two paths, but what i can tell you is that it will only take O(n**2) for the last test case that you gave, finding the roots will be only O(1) (2 extra iteration at max).
(19 Jan '13, 02:44)

Can you that what is my problem ID is :1681905 answered 15 Jan '13, 15:59
2
Did you test you program at least somehow? One suggestion is that you should use long long type for unsec and print it as printf("%lld ",unsec).
(15 Jan '13, 16:15)
are you sure this test case my program give wrong answer because in my computer answer is 1 not 0.are you sure that you check correct submit my program id is:1681905
(15 Jan '13, 17:00)
1
I look here
(15 Jan '13, 17:22)

The editorial is pretty nice. I wonder what was wrong with my implementation. Can you please have a look and let me know my error. It would be great. I'm unable to figure out. answered 15 Jan '13, 16:33
1
Try to use usual array instead of queue. I think the queue is the real bottleneck of your solution.
(17 Jan '13, 02:45)
Thanks for spending time to look into the code. As suggested, I replaced queue with usual array. But now I get a runtime error. Now what could be reason for this. http://www.codechef.com/viewsolution/1727148 Could you please look into it?
(17 Jan '13, 19:07)
It is quite hard to follow your code. Also why don't you declare
(17 Jan '13, 19:22)
I made all the suggested improvements. The code looks less cumbersome now. Also, the code for BFS is written only once. Instead of using a separate matrix to store the visited nodes, I make the value of node to 1 when it is visited. That helps me to preserve memory. I hope that would clarify my approach. Still I get runtime error. I am puzzled. Could you help me please?
(18 Jan '13, 13:28)
You should mark server[x][y1] = 1 when you add (x,y1) to hackX, hackY. Otherwise you could add the same cell several times. Probably this is also the reason of TLE for bfs with queue. Maybe fixing this in the first submission will make it faster. For example. You have (0,0), then you add (0,1) and (1,0) and then when you consider (0,1) you add (1,1) but not mark it, hence when you consider (1,0) you will add (1,1) again. So the reason of RE is that you add more than 350^2 elements in all.
(18 Jan '13, 13:37)
Thanks anton_lunyov. Got the solution accepted. I applied the same to my previous solution(queue) one. Both worked. Execution time of array one is better though. Thanks for devoting your time.
(18 Jan '13, 14:50)
Just for your notice. 0.96 is only for special test where we have no primes and each component consists of just one cell. For other tests time <= 0.5. Probably the reason of such slow down on this particular test is creating queue 350^2 times.
(18 Jan '13, 18:53)
showing 5 of 7
show all

Nice editorial. I have an unrelated question though. I used BFS instead of DFS. Everything else was same as you suggested in your editorial. But I was getting Wrong answer somehow. I tried it with many test cases generated by hand and it was working fine. How should I approach in finding problems in my code in such scenarios. Any help will be highly appreciated. BTW, my problem submission was http://www.codechef.com/viewsolution/1720890 If anyone can point to what test cases my program was failing, it will be really helpful. Thanks in advance. answered 15 Jan '13, 16:34
I used BFS as well. I got TLE. :(
(15 Jan '13, 18:00)
@vikram535 You have repeated the same mistake as hundreds of contestants and tens of contestants who asking for help after the contest. You should use 64bit integer type Regarding the bfs, see my answer above in the response
(17 Jan '13, 02:52)

I first used an integer array of size 10e7 for the sieve, but it ran out of memory though...had to half the size of the array and cancel all the even numbers. answered 15 Jan '13, 18:28
Actually the main your issue is declaring all arrays inside main().
(17 Jan '13, 11:28)
@anton_lunyov you mean to say if I declare my array globally I can use upto 1500M memory?
(17 Jan '13, 19:33)
Yes. Even 1536M :)
(17 Jan '13, 19:36)

What is problem in my solution.. I am getting WA http://www.codechef.com/viewsolution/1723138 answered 15 Jan '13, 18:42
Your output for this test
(17 Jan '13, 11:29)
How is it coming out to be 2. Can you please explain?
(21 Jan '13, 13:13)
Its just for testing '1' at place (1,1)... Got my mistake... its a silly one in function kr1(int,int)....wrote pass[i][j] instead of typ[i]][j]... damn shit....
(21 Jan '13, 18:18)

To implement grid hacking in java, if i use an ArrayDeque or a LinkedList, i get TLE( http://www.codechef.com/viewsolution/1724620 ), while if i change the data structure to ArrayList( http://www.codechef.com/viewsolution/1724632 ), i get one of the fastest execution times in java. Any reason as to why this is happening? answered 15 Jan '13, 21:09

I got AC after using Sieve of Eratosthenes but I want to implement it by another method by which I couldn't. We can find all prime numbers less than 10^7 by simply making another prime number program and copy the output and assign it to array in our program arr[]={all prime numbers less than 10^7 that we already have.}. Now just apply a for loop for(i=0;i<arr.size;i++) arr1[arr[i]]=i; now just find if any number is a prime by if(arr1[num]!=0) return arr1[num]; but In the above approach I couldn't assign the whole set of prime numbers to arr[] manually by copy paste. I am getting error "/usr/lib/gcc/i486linuxgnu/4.3.2/../../../../lib/crt1.o: In function answered 17 Jan '13, 14:37
This is because source limit is 50000B.
(17 Jan '13, 14:50)
@anton_lunyov : I don't think its a cheat. Its the first thought that came in my mind after reading this question. :)
(17 Jan '13, 16:16)

Can the admins tell what's wrong with http://www.codechef.com/viewsolution/1703688? answered 21 Jan '13, 12:49
1
Your code is very long. Delete at least all this annoying debugging printf before asking for help.
(21 Jan '13, 15:04)
New id is 1742822. Thanks.
(21 Jan '13, 16:05)
Try this test:
(21 Jan '13, 23:06)
I have updated the editorial. Please read and follow the SUGGESTION at the beginning of editorial.
(22 Jan '13, 02:38)
That's great anton_lunyvon. Thanks a lot.
(22 Jan '13, 09:59)

I'm getting WA my solution is this http://www.codechef.com/viewsolution/1742829. answered 21 Jan '13, 16:15
Hi There, your solution did not work on the following test case. The answer is 9076. It is giving 5087.
(21 Jan '13, 16:27)

i have checked all the test cases which u have provided in the editorial and it gives right answer.I am unable to figure out the problem. http://www.codechef.com/viewsolution/1744261 answered 22 Jan '13, 09:59
In routines oddserver and evenserver you should check before accessing valid[k][l] (or valid[m][n]) that cell (k,l) (or (m,n)) lies inside the grid. Probably this is the reason.
(22 Jan '13, 12:36)
@anton_lunyov (valid[i][j] is itself a array which has 1 at (i,j) if i,j lies inside the grid otherwise valid[i][j] contains 0) it is also workin well .please help to sort out this problem ,still unable to fiure out the problem
(23 Jan '13, 15:53)
In
you should write
where The same should be applied to If you will have troubles with fixing it you can refer to my edit of your code that got AC:
(23 Jan '13, 16:04)

I habe a problem in my solution http://www.codechef.com/viewsolution/1745646 based on the editorial which seems to be more a compiler/c++ problem then an algorithmic problem. I got the error "Access violation reading location 0x01A4B7A4" when trying to read from my big prime array. Can anyone help? answered 23 Jan '13, 13:30
1
Your array for primes is too small. Add one zero to K. Like here:
(23 Jan '13, 14:15)
Greatly appreciated, Anton! I should have noticed it by myself!
(23 Jan '13, 22:48)

Please have a look at the following solution : http://www.codechef.com/viewsolution/1746818 It gave correct results for the test cases mentioned in the editorial here, those in the problem statement and some cases generated by myself. But still it displays 'Wrong Result' here. Please help! answered 24 Jan '13, 13:19
Use
(24 Jan '13, 14:27)
thank you for the correction. i tried another approach.. facing a similar problem..
(24 Jan '13, 23:35)
Wow! Your solution fails for only one grid among 80 grids we have in official test data. It is a grid having the following structure: N=350, a[i][j] are all even nonprimes, except very small percent of odd nonprimes. Each group of odd passwords is generated as a boundary of a small square. Your solution is quite hard to follow so I can only suggest you to generate test of the above structure for smaller size and compare your answer with the answer generated by the correct program.
(25 Jan '13, 01:08)
approach is as : 1. generate prime numbers index. 2. read data (simultaneously add attempts for primes). store odd/even flag for remaining. 3. get_neighbors() will store 'valid' neighbors for each data. 'valid' means  (i) it is either [i+1][j] or [i][j+1]. (ii) it has to be of same type (odd/even) nonprimes. 4. 'tags[i][j]' for each member is assigned as 'i*N+j'. 5. arrange_and_compute() will do traversal over all members and update 'valid' neighbors with lowest tags among them. this is done in loop until there is no change in an iteration. this was an attempt on amortization. will see!
(25 Jan '13, 15:11)

Can anybody look at my solution and explain why am i getting Runtime error(segmentation fault). i cant see why..:( answered 22 Jun '14, 19:28

my code runs fine on my machine but shows wrong answer on submission Please help my solution is here http://www.codechef.com/viewsolution/5203370 answered 23 Oct '14, 23:06

Hi, I just studied DFS and then searched this problem through question tags. I passed the given test cases and also the cases given in editorial. But still couldn't get AC. I made these solutions: 1) https://www.codechef.com/viewsolution/8801554 > It gave me WA 2) https://www.codechef.com/viewsolution/8801563 > It gave me RE The only difference between both these solutions is that i have changed my counter variable which is needed to be printed from long to long long. I would be so glad if anyone could explain me the bug. answered 17 Nov '15, 18:26

Hey I solved the problem with same approach as given above but it's showing wrong answer. Please can anyone help answered 21 Jul '17, 08:16

Hey I solved the problem with same approach as given above but it's showing wrong answer. Please can anyone help answered 21 Jul '17, 08:17

The test data, http://pastebin.com/raw.php?i=j6UWCAZ5 is too large for me to debug the program, so I am unable to find why is it giving 421211088 instead of correct result. Can you please help. My solution is http://www.codechef.com/viewsolution/1696242 answered 21 Jan '13, 23:38
I have updated the editorial. Please read and follow the SUGGESTION at the beginning of editorial.
(22 Jan '13, 02:41)

fantastic editorial. loved it!
@editorialist : great work to give additional links to similar problems :) thanks. Things are really changing nicely in new year :)
Its Nice.....